local GiveWeaponToPed_RDR2 = function(...)
    return Citizen.InvokeNative(0x5E3BDDBCB83F3D84, ...)
end


local weapons = {
    ["Melee"] = {
        "weapon_melee_knife_jawbone",
        "weapon_melee_machete",
        "weapon_melee_torch",
        "weapon_melee_knife",
        "weapon_melee_machete_horror",
        "weapon_melee_knife_trader",
        "weapon_melee_machete_collector",
        "weapon_melee_knife_horror",
        "weapon_melee_knife_rustic"
    },
    ["Pistol"] = {
        "weapon_pistol_volcanic",
        "weapon_pistol_m1899",
        "weapon_pistol_semiauto",
        "weapon_pistol_mauser"
    },
    ["Revolver"] = {
        "weapon_revolver_doubleaction",
        "weapon_revolver_cattleman",
        "weapon_revolver_cattleman_mexican",
        "weapon_revolver_lemat",
        "weapon_revolver_schofield",
        "weapon_revolver_doubleaction_gambler",
        "weapon_revolver_navy",
        "weapon_revolver_navy_crossover"
    },
    ["Repeater"] = {
        "weapon_repeater_evans",
        "weapon_repeater_henry",
        "weapon_repeater_winchester",
        "weapon_repeater_carbine"
    },
    ["Rifle"] = {
        "weapon_rifle_springfield",
        "weapon_rifle_boltaction",
        "weapon_rifle_varmint",
        "weapon_rifle_elephant"
    },
    ["Shotgun"] = {
        "weapon_shotgun_sawedoff",
        "weapon_shotgun_doublebarrel_exotic",
        "weapon_shotgun_pump",
        "weapon_shotgun_repeating",
        "weapon_shotgun_semiauto",
        "weapon_shotgun_doublebarrel"
    },
    ["Sniper"] = {
        "weapon_sniperrifle_carcano",
        "weapon_sniperrifle_rollingblock"
    },
    ["Bow"] = {
        "weapon_bow",
        "weapon_bow_improved"
    },
    ["Lasso"] = {
        "weapon_lasso",
        "weapon_lasso_reinforced"
    },
    ["Thrown"] = {
        "weapon_melee_hatchet",
        "weapon_melee_hatchet_hunter",
        "weapon_thrown_molotov",
        "weapon_thrown_tomahawk_ancient",
        "weapon_thrown_tomahawk",
        "weapon_thrown_dynamite",
        "weapon_melee_hatchet_double_bit",
        "weapon_thrown_throwing_knives",
        "weapon_melee_cleaver",
        "weapon_thrown_bolas",
        "weapon_thrown_poisonbottle",
        "weapon_thrown_bolas_hawkmoth",
        "weapon_thrown_bolas_ironspiked",
        "weapon_thrown_bolas_intertwined"
    },
    ["Petrolcan"] = {
        "weapon_moonshinejug_mp"
    },
    ["Fishingrod"] = {
        "weapon_fishingrod"
    },
    ["Held"] = {
        "weapon_melee_davy_lantern",
        "weapon_kit_binoculars",
        "weapon_kit_camera",
        "weapon_kit_camera_advanced",
        "weapon_kit_binoculars_improved",
        "weapon_kit_metal_detector",
        "weapon_melee_lantern_halloween"
    }
}

Citizen.CreateThread(function()
    while DONE.Weapon == nil do
        Citizen.Wait(100)
    end

    local infiniteammo = DONE.Weapon:AddCheckbox({ label = "Infinite ammo", value = "n" })
    infiniteammo:On("check", function(btn)
        SetPedInfiniteAmmo(PlayerPedId(), true)
    end)
    infiniteammo:On("uncheck", function(btn)
        SetPedInfiniteAmmo(PlayerPedId(), false)
    end)

    local infiniteclip = DONE.Weapon:AddCheckbox({ label = "Infinite ammo clip", value = "n" })
    infiniteclip:On("check", function(btn)
        Citizen.InvokeNative(0xFBAA1E06B6BCA741, PlayerPedId(), true)
    end)
    infiniteclip:On("uncheck", function(btn)
        Citizen.InvokeNative(0xFBAA1E06B6BCA741, PlayerPedId(), false)
    end)

    local l = 0
    for group, tabl in orderedPairs(weapons) do
        l = l + 1
        math.randomseed(GetGameTimer() + l + 1337 + 50003)

        local sliderweapons = {}
        for _, weapon in ipairs(tabl) do
            table.insert(sliderweapons, { label = GetLabelTextByHash(weapon), value = weapon })
        end

        local groupslider = DONE.Weapon:AddSlider({ label = group, value = 1, values = sliderweapons })
        groupslider:On("select", function(btn, value)
            local ped = PlayerPedId()
            local weaponHash = GetHashKey(value)
            if HasPedGotWeapon(ped, weaponHash) then
                RemoveWeaponFromPed(ped, weaponHash, true, GetHashKey("REMOVE_REASON_DEFAULT"))
            else
                -- GiveWeaponToPed(ped, weaponHash, int ammoCount, bForceInHand, bForceInHolster, attachPoint, bAllowMultipleCopies, float p7, float p8, addReason, bIgnoreUnlocks, float permanentDegradation, bool p12);
                GiveWeaponToPed_RDR2(ped, weaponHash, 10, true, false, 0, false, 0.5, 1.0, GetHashKey("ADD_REASON_DEFAULT"), true, 0.0, false)
                SetCurrentPedWeapon(ped, weaponHash, true)
            end
        end)
    end
end)